package cn.com.ty.lift.system.banner.controller;


import cn.com.ty.lift.system.banner.dao.entity.BannerImage;
import cn.com.ty.lift.system.banner.service.impl.BannerImageServiceImpl;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * <p>
 * banner图管理 前端控制器
 * </p>
 *
 * @author wang-hai-cheng
 * @since 2019-12-31
 */
@RestController
@AllArgsConstructor
@RequestMapping("/banner")
public class BannerImageController {
    private final BannerImageServiceImpl bannerService;

    @PostMapping("/list")
    public RestResponse list(@RequestBody BannerImage banner) {
        List<BannerImage> banners = bannerService.list(new QueryWrapper<BannerImage>()
                .eq(banner.getType() != null, "type", banner.getType())
                .orderByAsc("serial_no"));
        if (banners.isEmpty()) {
            return RestResponse.success();
        }
        for (BannerImage bannerImage : banners) {
            bannerImage.setName(""+bannerImage.getName());
        }
        return RestResponse.success(banners);
    }

    @PostMapping("/add")
    public RestResponse add(@RequestBody BannerImage bannerImage) {
        if (bannerService.save(bannerImage)) {
            return RestResponse.success(null, "成功");
        }
        return RestResponse.fail();
    }

    @PostMapping("/modify")
    public RestResponse modify(@RequestBody BannerImage bannerImage) {
        if (bannerService.saveOrUpdate(bannerImage)) {
            return RestResponse.success(null, "成功");
        }
        return RestResponse.fail();
    }

    @PostMapping("/delete")
    public RestResponse delete(@RequestBody BannerImage bannerImage) {
        if (bannerService.removeById(bannerImage)) {
            return RestResponse.success(null, "成功");
        }
        return RestResponse.fail();
    }

    @PostMapping("/upFile")
    public RestResponse upFile(@RequestParam Long id, @RequestParam MultipartFile file) {
        return bannerService.upFile(id, file);
    }
}